package de.fhwiesbaden.poly;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;


public class PolygonGUI extends JFrame {

	private static final long serialVersionUID = -4760308052639469840L;

	HashMap<Integer, Polygon> polymap = new HashMap<Integer, Polygon>();
	final FileHandler fh = new FileHandler();
	int currentpoly = 0;
	int polies = 0;
	Polygon currentPolygon = null;
	PolygonPanel polypanel;
	int x = 0, y = 0;
	String str = null;
	int s = '0';
	
	/* Buttons */
	JButton newPoly;
	JButton choosePoly;
	JButton addPoint;
	JButton addQuad;
	JButton delPoint;
	JButton printPoly;
	JButton paintPoly;
	JButton delPoly;
	JButton loadPoly;
	JButton savePoly;
	JButton quit;
	JButton test;
	
	
	public PolygonGUI() {
		setTitle("Polygone");
		setResizable(true);
		setLayout(new GridBagLayout());
		createButtons();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pack();
		setLocationRelativeTo(null);
	}

	public void createButtons() {

		newPoly = new JButton("Neues Polygon");
		newPoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				currentPolygon = new Polygon();
				polymap.put(polies, currentPolygon);
				currentpoly = polies;
				polies = polymap.size();
				//JOptionPane.showMessageDialog(getParent(), "Neues Polygon angelegt.");
			}
		});
		
		choosePoly = new JButton("Polygon wählen");
		choosePoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!polymap.isEmpty()) {
					str = JOptionPane.showInputDialog("Polygon waehlen: ");
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					currentpoly = s;
					currentPolygon = polymap.get(s);
					if (polymap.size()-1 < s) {
						JOptionPane.showMessageDialog(getParent(), "Polygon "+s+" existiert nicht!\n");
					} else JOptionPane.showMessageDialog(getParent(), "Polygon "+s+" gewählt");
				} else JOptionPane.showMessageDialog(getParent(), "Es liegt kein Polygon vor.\n");
			}
		});

		addPoint = new JButton("Neuer Punkt");
		addPoint.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!polymap.isEmpty()) {
					str = JOptionPane.showInputDialog("x waehlen:");
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					x = s;
					str = JOptionPane.showInputDialog("y waehlen:");
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					y = s;
					JOptionPane.showMessageDialog(getParent(), "\nPunkt ["+x+", "+y+"] wurde hinzugefuegt.\n");
					currentPolygon.addPoint(new Pair(x,y));
				} else JOptionPane.showMessageDialog(getParent(), "Es liegt kein Polygon vor.\n");
			}
		});

		addQuad = new JButton("Neues Quadrat");
		addQuad.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!polymap.isEmpty()) {
					str = JOptionPane.showInputDialog("Seitenlaenge x waehlen: ");
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					str = JOptionPane.showInputDialog("Position x waehlen: ");
					try {
						x = Integer.parseInt(str);
						} catch (Exception E){}
					str = JOptionPane.showInputDialog("Position y waehlen: ");
						try {
							y = Integer.parseInt(str);
							} catch (Exception E){}
					Quadrat quad = new Quadrat(s);
					quad.getQuad(x,y);
					currentPolygon.addPoint(quad.get(0));
					currentPolygon.addPoint(quad.get(1));
					currentPolygon.addPoint(quad.get(2));
					currentPolygon.addPoint(quad.get(3));
					JOptionPane.showMessageDialog(getParent(), "Quadrat wurde hinzugefügt.");
				} else JOptionPane.showMessageDialog(getParent(), "Es liegt kein Polygon vor in welchem das Quadrat platz finden koennte!\n");
			}
		});

		delPoint = new JButton("Punkt löschen");
		delPoint.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!polymap.isEmpty()) {
					str = JOptionPane.showInputDialog("Punkt loeschen: ");
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					if (s > 0 && s-1 < (polymap.get(currentpoly).getSize())) {
						currentPolygon.delPoint(s-1);
					} else JOptionPane.showMessageDialog(getParent(), "\nPunkt "+(s)+" existiert nicht!\n");
				} else JOptionPane.showMessageDialog(getParent(), "Es liegt kein Polygon vor.\n");
			}
		});

		printPoly = new JButton("Polygon ausgeben");
		printPoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				String str = "Eingetragene Polygonpunkte:\n";
				if (!polymap.isEmpty()) {
					for (int i = 0; i < polymap.size(); i++) {
						String fill;
						if (currentpoly == i) fill = " (aktuell)"; else fill = "";
						str += "\nPolygon "+i+fill+":\n-----------\n";
						str += polymap.get(i).toString();
					}
					//JOptionPane.showMessageDialog(getParent(), str);
					System.out.println(str);
				} else JOptionPane.showMessageDialog(getParent(), "Es liegen keine Polygone vor.\n");
			}
		});

		paintPoly = new JButton("Polygon zeichnen");
		paintPoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!polymap.isEmpty()) {
					polypanel = new PolygonPanel("Polygone", currentPolygon);
					for (int i = 0; i < polymap.size(); i++) {
						polypanel.addPolygon(polymap.get(i));
					}
					JFrame f = new JFrame();
					//f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
					f.setTitle("\"Polygone\" by Andreas Lind");
					f.setSize (800, 600);
					f.add(polypanel);
					f.setVisible(true);
				} else JOptionPane.showMessageDialog(getParent(), "Es liegen keine Polygone zum Zeichnen vor.\n");
			}
		});

		delPoly = new JButton("Polygon löschen");
		delPoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				if (!polymap.isEmpty()) {
					str = JOptionPane.showInputDialog("Polygon zum Loeschen: ");
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					for (int i = polymap.size()-1; i >= s; i--){
						polymap.put(i-1, polymap.get(i));
					}
					polymap.remove(polymap.size()-1);
					polies = polymap.size();
					currentpoly = 0;
					JOptionPane.showMessageDialog(getParent(), "Polygon "+s+" wurde gelöscht");
				} else JOptionPane.showMessageDialog(getParent(), "Es liegen keine Polygone zum Loeschen vor.\n");
			}
		});

		loadPoly = new JButton("Polygon laden");
		loadPoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				JFileChooser chooser = new JFileChooser();
			    int returnVal = chooser.showOpenDialog(getParent());
				try {
			    if(returnVal == JFileChooser.APPROVE_OPTION)
					try {
						polymap = (HashMap<Integer, Polygon>)(fh.readFile(chooser.getSelectedFile().getName()));
					} catch (ClassNotFoundException e1) {
						e1.printStackTrace();
					}
				} catch (IOException E) {
					JOptionPane.showMessageDialog(getParent(), "\nDatei mit diesem Namen ist nicht vorhanden!\n");
				}
				polies = polymap.size();
				currentpoly = 0;
				currentPolygon = polymap.get(0);
				JOptionPane.showMessageDialog(getParent(), "Polygone wurden aus der Datei \"" +chooser.getSelectedFile().getName()+ "\" eingelesen\n");
			}
		});

		savePoly = new JButton("Polygon speichern");
		savePoly.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
			    JFileChooser chooser = new JFileChooser();
			    int returnVal = chooser.showSaveDialog(getParent());
				try {
			    if(returnVal == JFileChooser.APPROVE_OPTION)
						fh.writeFile(chooser.getSelectedFile().getName(), polymap);
				} catch (IOException E) {
					JOptionPane.showMessageDialog(getParent(), "\nDatei konnte nicht geschrieben werden!\n");
				}
				JOptionPane.showMessageDialog(getParent(), "Datei wurde unter dem Namen \"" +chooser.getSelectedFile().getName()+ "\" abgelegt\n");
			}
		});

		quit = new JButton("Beenden");
		quit.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				System.exit(1);
			}
		});
		
		test = new JButton("<<Hardcore-Test>>");
		test.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent e) {
				highEndTest();
			}
		});
		
		GridBagConstraints a1 = new GridBagConstraints();
		a1.gridx = 0;
		a1.gridy = 0;
		add(newPoly, a1);
		GridBagConstraints a2 = new GridBagConstraints();
		a2.gridx = 0;
		a2.gridy = 1;
		add(choosePoly, a2);
		GridBagConstraints a3 = new GridBagConstraints();
		a3.gridx = 0;
		a3.gridy = 2;
		add(addPoint, a3);
		GridBagConstraints a4 = new GridBagConstraints();
		a4.gridx = 0;
		a4.gridy = 3;
		add(addQuad, a4);
		GridBagConstraints a5 = new GridBagConstraints();
		a5.gridx = 0;
		a5.gridy = 4;
		add(delPoint, a5);
		GridBagConstraints b1 = new GridBagConstraints();
		b1.gridx = 0;
		b1.gridy = 5;
		add(printPoly, b1);
		GridBagConstraints b2 = new GridBagConstraints();
		b2.gridx = 0;
		b2.gridy = 6;
		add(paintPoly, b2);
		GridBagConstraints b3 = new GridBagConstraints();
		b3.gridx = 0;
		b3.gridy = 7;
		add(delPoly, b3);
		GridBagConstraints b4 = new GridBagConstraints();
		b4.gridx = 0;
		b4.gridy = 8;
		add(loadPoly, b4);
		GridBagConstraints b5 = new GridBagConstraints();
		b5.gridx = 0;
		b5.gridy = 9;
		add(savePoly, b5);
		GridBagConstraints b6 = new GridBagConstraints();
		b6.gridx = 0;
		b6.gridy = 10;
		add(quit, b6);
		GridBagConstraints b7 = new GridBagConstraints();
		b7.gridx = 0;
		b7.gridy = 11;
		add(test, b7);
	}
	
	public void highEndTest(){
		newPoly.doClick();
		for (int x = 10; x<800; x+=100) {
			for (int y = 10; y<600; y+=100) {
				currentPolygon.addPoint(new Pair(x,y));
			}
		}
		newPoly.doClick();
		for (int x = 40; x<800; x+=100) {
			for (int y = 40; y<600; y+=100) {
				currentPolygon.addPoint(new Pair(x,y));
			}
		}
		newPoly.doClick();
		for (int x = 0; x<800; x+=10) {
			for (int y = 0; y<600; y+=10) {
				currentPolygon.addPoint(new Pair(x,y));
			}
		}
		newPoly.doClick();
		paintPoly.doClick();
		for (int x = 0; x<800; x+=1) {
			for (int y = 0; y<600; y+=1) {
				currentPolygon.addPoint(new Pair(x,y));
			}
		}
	}
	
	public static void main(String[] args) {
		PolygonGUI pGui = new PolygonGUI();
		pGui.setVisible(true);
	}

}
