package de.fhwiesbaden.poly;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.*;


public class PolygonPanel extends JPanel {
	
	private static final long serialVersionUID = -53605842021797168L;
	
	public int startX, startY, endX, endY;
	
	private ArrayList<Polygon> polylist;
	public Polygon current;
	
	public PolygonPanel(String name, Polygon curr) {
		
		polylist = new ArrayList<Polygon>();
		
		this.current = curr;
		
		setName(name);
		
		this.setFocusable(true);
		
		this.addMouseListener(new MouseListener(){

			@Override
			public void mouseClicked(MouseEvent arg0) {}

			@Override
			public void mouseEntered(MouseEvent arg0) {}

			@Override
			public void mouseExited(MouseEvent arg0) {}

			@Override
			public void mousePressed(MouseEvent ev) {
				startX = ev.getX();
				startY = ev.getY();
			}

			@Override
			public void mouseReleased(MouseEvent ev) {
				endX = ev.getX();
				endY = ev.getY();
				for (Polygon poly : polylist) {
					for (Pair pair : poly) {
						if (pair.x-5 < startX && pair.x+5 > startX && pair.y-5 < startY && pair.y+5 > startY) {
							pair.x += endX - startX;
							pair.y += endY - startY; 
						}
					}
				}
				repaint();
			}
		});
		
		this.setFocusTraversalKeysEnabled(true);
		
		this.addKeyListener(new KeyListener(){

			@Override
			public void keyPressed(KeyEvent ev) {
				if (ev.getKeyChar() == 'n') {
					current.add(new Pair(startX, startY));
					repaint();
				}
			}

			@Override
			public void keyReleased(KeyEvent arg0) {}

			@Override
			public void keyTyped(KeyEvent arg0) {}
			
		});
	}
	
	public void addPolygon(Polygon poly) {
		this.polylist.add(poly);
	}
	
	public void refresh() {
		repaint();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		for (Polygon poly : polylist) {
			if (poly.size() > 0) {
				for (int i = 1; i < poly.size(); i++) {
					g.drawLine(poly.get(i-1).x, poly.get(i-1).y, poly.get(i).x, poly.get(i).y);
					g.fillOval(poly.get(i-1).x-5, poly.get(i-1).y-5, 10, 10);
				}
				g.drawLine(poly.get(0).x, poly.get(0).y, poly.get(poly.size()-1).x, poly.get(poly.size()-1).y);
				g.fillOval(poly.get(poly.size()-1).x-5, poly.get(poly.size()-1).y-5, 10, 10);
			}
		}
	}
}
