package de.fhwiesbaden.poly;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;

import javax.swing.JFrame;


public class PolygonUtil {
	
	public static void main(String[] args) throws IOException, ClassNotFoundException {
		
		HashMap<Integer, Polygon> polymap = new HashMap<Integer, Polygon>();
		final FileHandler fh = new FileHandler();
		int currentpoly = 0;
		int polies = 0;
		Polygon currentPolygon = null;
		PolygonPanel polypanel;
		int x = 0, y = 0;
		String str = null;
		int s = '0';
		BufferedReader buf = new BufferedReader(new InputStreamReader(System.in));

		System.out.println("\nProgramm zur Ein- und Ausgabe von Polygonen\n");
		
		while (s != 'x') {
			
			System.out.println("(1)\tNeues Polygon.");
			System.out.println("(2)\tPolygon waehlen.");
			System.out.println("(3)\tPunkt hinzufuegen.");
			System.out.println("(4)\tQuadrat hinzufuegen.");
			System.out.println("(5)\tPunkt loeschen.");
			System.out.println("(6)\tPolygonpunkte ausgeben.");
			System.out.println("(7)\tPolygone zeichnen.");
			System.out.println("(8)\tPolygon loeschen.");
			System.out.println("(l)\tPolygone laden.");
			System.out.println("(s)\tPolygone speichern.");
			System.out.println("(0)\tBeenden.\n");

			str = buf.readLine();

			if (str.length() == 1) {
				switch (str.charAt(0)) {
				case 's': 
					System.out.println("\nBitte geben Sie den gewuenschten Dateinamen zum Speichern ein: ");
					str = buf.readLine();
					try {
						fh.writeFile(str, polymap);
					} catch (IOException E) {
						System.out.println("\nDatei konnte nicht geschrieben werden!\n");
					}
					System.out.println("Datei wurde unter dem Namen \"" +str+ "\" abgelegt\n");
					str = "99";
					break;
	
				case 'l': 
					System.out.println("\nBitte geben Sie den gewuenschten Dateinamen zum Laden ein: ");
					str = buf.readLine();
					try {
						polymap = (HashMap<Integer, Polygon>)(fh.readFile(str));
					} catch (IOException E) {
						System.out.println("\nDatei mit diesem Namen ist nicht vorhanden!\n");
					}
					polies = polymap.size();
					currentpoly = 0;
					currentPolygon = polymap.get(0);
					System.out.println("Polygone wurden aus der Datei \"" +str+ "\" eingelesen\n");
					str = "99";
					break;
				}
			}
			
			
			try {
				s = Integer.parseInt(str);
			} catch (Exception E){
				//es war keine Zahl
			}

			
			switch (s) {
			
			case 1:
				currentPolygon = new Polygon();
				polymap.put(polies, currentPolygon);
				currentpoly = polies;
				polies = polymap.size();
				break;
				
			case 2:
				if (!polymap.isEmpty()) {
					System.out.print("Polygon waehlen: ");
					str = buf.readLine();
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					currentpoly = s;
					currentPolygon = polymap.get(s);
					if (polymap.size()-1 < s) {
						System.out.println("Polygon "+s+" existiert nicht!\n");
					}
				} else System.out.println("Es liegt kein Polygon vor.\n");
				break;
			
			case 3: 
				if (!polymap.isEmpty()) {
					System.out.println("Punkt waehlen:");
					System.out.print("x: ");
					str = buf.readLine();
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					x = s;
					System.out.print("y: ");
					str = buf.readLine();
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					y = s;
					System.out.println("\nPunkt ["+x+", "+y+"] wurde hinzugefuegt.\n");
					currentPolygon.addPoint(new Pair(x,y));
				} else System.out.println("Es liegt kein Polygon vor.\n");
				break;

			case 4:
				if (!polymap.isEmpty()) {
					System.out.print("Seitenlaenge waehlen: ");
					str = buf.readLine();
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					System.out.print("Position x waehlen: ");
					str = buf.readLine();
					try {
						x = Integer.parseInt(str);
						} catch (Exception E){}
					System.out.print("Position y waehlen: ");
						str = buf.readLine();
						try {
							y = Integer.parseInt(str);
							} catch (Exception E){}
					Quadrat quad = new Quadrat(s);
					quad.getQuad(x,y);
					currentPolygon.addPoint(quad.get(0));
					currentPolygon.addPoint(quad.get(1));
					currentPolygon.addPoint(quad.get(2));
					currentPolygon.addPoint(quad.get(3));
				} else System.out.println("Es liegt kein Polygon vor in welchem das Quadrat platz finden koennte!\n");
				break;
								
			case 5:
				if (!polymap.isEmpty()) {
					System.out.println("Punkt loeschen: ");
					str = buf.readLine();
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					if (s > 0 && s-1 < (polymap.get(currentpoly).getSize())) {
						currentPolygon.delPoint(s-1);
					} else System.out.println("\nPunkt "+(s)+" existiert nicht!\n");
				} else System.out.println("Es liegt kein Polygon vor.\n");
				break;
				
			case 6:
				if (!polymap.isEmpty()) {
					System.out.println("Eingetragene Polygonpunkte:");
					for (int i = 0; i < polymap.size(); i++) {
						String fill;
						if (currentpoly == i) fill = " (aktuell)"; else fill = "";
						System.out.println("\nPolygon "+i+fill+":\n-----------");
						polymap.get(i).printPoly();
					}
					System.out.println("");
				} else System.out.println("Es liegen keine Polygone vor.\n");
				break;
				
			case 7:
				if (!polymap.isEmpty()) {
					polypanel = new PolygonPanel("Polygone", currentPolygon);
					for (int i = 0; i < polymap.size(); i++) {
						polypanel.addPolygon(polymap.get(i));
					}
					JFrame f = new JFrame();
					//f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
					f.setTitle("\"Polygone\" by Andreas Lind");
					f.setSize (800, 600);
					f.add(polypanel);
					f.setVisible(true);
				} else System.out.println("Es liegen keine Polygone zum Zeichnen vor.\n");
				break;
				
			case 8:
				if (!polymap.isEmpty()) {
					System.out.print("Polygon zum Loeschen: ");
					str = buf.readLine();
					try {
						s = Integer.parseInt(str);
						} catch (Exception E){}
					for (int i = polymap.size()-1; i >= s; i--){
						polymap.put(i-1, polymap.get(i));
					}
					polymap.remove(polymap.size()-1);
					polies = polymap.size();
					currentpoly = 0;
				} else System.out.println("Es liegen keine Polygone zum Loeschen vor.\n");
				break;

			case 0:
				System.exit(1);
				
			case 99:
				break;

			default: System.out.println("Falsche Eingabe!"); 

			}		
		}	
	}
	
}
